---
title: Windows build prerequisites using cygwin
slug: >-
  Mozilla/Developer_guide/Build_Instructions/Windows_build_prerequisites_using_cygwin
tags:
  - Build documentation
  - Developing Mozilla
---
<div>{{page("/en-US/docs/Build_Documentation/TOC")}}</div>

<h2 id="This_document_is_for_historical_use_only">This document is for historical use only</h2>

<p>{{Note('This document is a guide to the build prerequisites for building the Mozilla 1.9 codebase before the introduction of the MozillaBuild system in March 2007. If you are building Firefox 3 or greater, please see the standard <a href="/en-US/docs/Windows_Build_Prerequisites" title="Windows Build Prerequisites">Windows Build Prerequisites</a>. <strong>For building Firefox 2, Firefox 1.5, and other Mozilla products based on pre-1.9 branches, see the <a href="/en-US/docs/Windows_Build_Prerequisites_(1.7_and_1.8_Branches)" title="Windows Build Prerequisites (1.7 and 1.8 Branches)">Windows Build Prerequisites on the 1.7 and 1.8 Branches</a>.</strong>')}}</p>

<p>If you are building very old versions of the Mozilla source code, from the 1.0 branch and earlier, follow the <a class="external" href="http://www.mozilla.org/build/win32-nmake.html">nmake build instructions</a>.</p>

<h2 id="Hardware_Requirements">Hardware Requirements</h2>
<p>Mozilla takes time to build. You need a development-class system:</p>
<ul>
  <li>Pentium III or equivalent processor, 1GHz or better, 1.5+GHz recommended</li>
  <li>512 MB RAM, 1 GB recommended</li>
  <li>1.5 GB NTFS or 3 GB FAT disk space, or more</li>
  <li>Windows NT-class operating system (NT4.0, W2K (SP4?), Windows XP and Windows Vista)</li>
</ul>

<h2 id="Software_Requirements">Software Requirements</h2>
<p>The following software needs to be installed for a standard Windows build.</p>
<p>Mozilla may not build if some tools are installed at a path that contains spaces or other breaking characters such as pluses, quotation marks, or meta characters. The Visual C++ tools may be installed in a directory which contains spaces (the default install location is preferred).</p>

<h3 id="GNU_Tools_for_Microsoft_Windows_.28Cygwin.29">GNU Tools for Microsoft Windows (Cygwin)</h3>
<p>Cygwin is a Linux-like environment with GNU tools for Windows. Mozilla uses a developer set of GNU packages, which must be installed. These include gawk, make and zip utilities. GCC is not used and does not need to be installed. You must have Cygwin 1.1.6 or higher. You can have only one cygwin version installed on your operating system; concurrent installations may interfere with each other and cause errors.</p>
<p>Click here to run <a class="link-ftp" href="ftp://ftp.cygwin.com/pub/cygwin/setup.exe">setup.exe</a> and follow the installation instructions. The Cygwin installer wizard runs as a Windows program. One page of the wizard presents an outline view of categories and packages. You must add packages beyond the default set.</p>
<p>If you'll be using Cygwin only to build Mozilla, then install only the default packages and the packages needed by Mozilla. In the version of the installer current at this writing (version 2.510.2.2), the <strong>non-default</strong> packages are:</p>
<ul>
  <li>zip, unzip (under Archive)</li>
  <li>cvs (under Devel, only if you check out from CVS, not using tarballs)</li>
  <li>libiconv (under Devel, only if you build the installer)</li>
  <li>patchutils (under Devel)</li>
  <li>perl (under Interpreters)</li>
  <li>python (under Interpreters)</li>
  <li>make 3.80 is no longer available, see below</li>
</ul>
<p>If you may be using Cygwin's GNU tools for additional development, then install the editors, developer tools and interpreters, as well as anything else that looks interesting. Make sure you get all the packages Mozilla needs too, such as unzip and zip!</p>
<p>Here is the <strong>complete</strong> cygwin package list for building Mozilla. You can use it to double-check your packages, or to understand and customize the build process:</p>
<ul>
  <li>ash -- UNIX-like command line interpreter shell (Base category)</li>
  <li>coreutils -- GNU core utilities (includes fileutils, install, sh-utils, and textutils) (Base category)</li>
  <li>cvs -- concurrent versions system (Devel category)</li>
  <li>diffutils -- file comparison utility (Utils category)</li>
  <li>findutils (Base category)</li>
  <li>gawk -- pattern matching language (Base and Interpretors categories)</li>
  <li>grep -- text search tool (Base category)</li>
  <li>libiconv -- character set conversion (Devel category) - libiconv2 does not contain the iconv program needed for the installer</li>
  <li>make 3.80 (not 3.81, see below) -- dependency analyzer for software builds (Devel category)</li>
  <li>patchutils -- a small collection of programs that operate on patch files (Devel category)</li>
  <li>perl -- a scripting language used to control parts of the build (Interpreters category)</li>
  <li>python -- a scripting language used to control parts of the build (Interpreters category)</li>
  <li>sed -- a search and replace language (Base category)</li>
  <li>unzip -- zip file extraction (Archive category)</li>
  <li>zip -- zip file creation (Archive category)</li>
</ul>
<p>If you plan to modify the build system's configure.in files, you will need to install an editor (such as xemacs or joe) and the autoconf-2.13 (autoconf-2.5x and 2.60 doesn't work) packages as well.</p>
<p>For non-debug builds, it's recommended that you install the binutils package to make strip.exe available.</p>
<p>You may use <a class="external" href="http://activestate.com/Products/ActivePerl/">ActivePerl from ActiveState</a> instead of the perl package in Cygwin if you prefer.</p>

<h3 id="make">make</h3>
<p>make 3.80 is no longer available in the cygwin installer (version 3.81 will <strong>not</strong> work), so get it from <a class="external" href="http://cygwin.paracoda.com/release/make/make-3.80-1.tar.bz2">paracoda</a> or <a class="external" href="http://www.go-mono.com/archive/helper/make-3.80-1.tar.bz2">go-Mono</a> and place the included make.exe in your %cygwin%\bin\ directory, e.g. by starting a cygwin bash shell and executing</p>
<pre>cd /
tar xjf /cygdrive/c/where-your-download-is/make-3.80-1.tar.bz2
bin/make.exe --version
</pre>

<h3 id="moztools">moztools</h3>
<p>The moztools package contains binaries and libraries necessary to build Mozilla. A single zip file containing all moztools which works with all versions of MSVC is available at <a class="external" href="http://ftp.mozilla.org/pub/mozilla.org/mozilla/libraries/win32/moztools-static.zip">moztools-static.zip</a>.</p>
<p>The zip file contains a single folder named <em>moztools</em> that you should preserve. Unpack the zip file wherever you want the tools to be installed; however, Mozilla may not build if you install the moztools directory inside the cygwin directory. The MOZ_TOOLS environment variable should be set to point to this moztools folder. (You may rename the folder, as long as you update $MOZ_TOOLS accordingly.)</p>
<p>Note: The 1.8.1 branch (Firefox 2) is compatible with the moztools-static package. Older branches (including the 1.8.0 branch) are not; see the <a href="/en-US/docs/Windows_Build_Prerequisites_(1.7_and_1.8_Branches)" title="Windows_Build_Prerequisites_(1.7_&amp;_1.8_Branches)">historical build prerequisites</a> for details.</p>
<p>The moztools zip file does not contain the source for the components; if you are interested in building them from scratch, you can obtain the source <a class="link-ftp" href="ftp://ftp.mozilla.org/pub/mozilla.org/mozilla/libraries/win32/historic/src/">here</a>. The <a class="external" href="http://www.go-oo.org/">ooo-build</a> system for building OpenOffice.org builds the tools from scratch using this code and contains some relevant <a class="external" href="http://go-oo.org/ooo-build/patches/src680/">patches</a> for anyone who doesn't want to use the binaries provided.</p>

<h3 id="cvs">cvs</h3>
<p>CVS is the source control system used by Mozilla. You do not need cvs if you are only going to build from source tarballs downloaded via FTP. If so, you may skip this step.</p>
<p>To <a href="/en-US/docs/Developer_Guide/Source_Code/CVS" title="Mozilla_Source_Code_(CVS)">pull Mozilla sources</a>, cvs version 1.11 or higher is required. Cygwin CVS is recommended. WinCVS is also compatible. When installing CVS, you should also install an editor such as emacs or Xemacs.</p>

<h3 id="Compiler_&amp;_Linker">Compiler &amp; Linker</h3>
<p>For doing development on the CVS trunk (Mozilla 1.9 or higher), the standard compiler is Microsoft Visual C++, version 8. The free Express edition of Microsoft Visual C++ 8 (aka Visual C++ 2005 Express Edition) will work with some <a href="/en-US/docs/Developer_Guide/Build_Instructions/Windows_Prerequisites" title="Windows_Build_Prerequisites">extra tools and configure options</a>. Visual C++ 7.1 will also work. VC++ 7 is not recommended, and VC6 is not supported and will produce unusable builds.</p>
<p>The build may occur from within either a Windows command line shell or from a cygwin shell; if you use the Windows shell, you need to set up the compiler environment variables using the vcvars32.bat script that is installed along with Visual Studio (selecting "Visual C++ Command Prompt" from the Start menu entries for VS will execute this script for you in a new shell).</p>
<p>It is also possible (but not recommended) to compile Mozilla using the MinGW gcc compiler: see <a class="external" href="http://gemal.dk/mozilla/build.html">Compiling Mozilla with MinGW</a>.</p>

<h4 id="Table_of_supported_Visual_Studio_compilers">Table of supported Visual Studio compilers</h4>
<table class="standard-table">
  <tbody>
    <tr>
      <th>Branch</th>
      <th>HEAD<br>
        Gecko 1.9<br>
        Firefox 3</th>
      <th>MOZILLA_1_8_BRANCH<br>
        Gecko 1.8.1<br>
        Firefox 2</th>
      <th>MOZILLA_1_8_0_BRANCH<br>
        Gecko 1.8<br>
        Firefox 1.5.0.x</th>
    </tr>
    <tr>
      <th>VC6</th>
      <td style="background-color: rgb(255,102,102);"><font>No</font></td>
      <td style="background-color: #6f6;">Yes <span style="font-size: smaller;">(Official)</span></td>
      <td style="background-color: #6f6;">Yes <span style="font-size: smaller;">(Official)</span></td>
    </tr>
    <tr>
      <th>VC7 (Visual Studio 2002)</th>
      <td style="background-color: #ffcc66;">Not really</td>
      <td style="background-color: #6f6;">Yes</td>
      <td style="background-color: #6f6;">Yes</td>
    </tr>
    <tr>
      <th>VC7.1 (Visual Studio 2003)</th>
      <td style="background-color: #6f6;">Yes</td>
      <td style="background-color: #6f6;">Yes</td>
      <td style="background-color: #6f6;">Yes</td>
    </tr>
    <tr>
      <th>VC8 (Visual Studio 2005)</th>
      <td style="background-color: #6f6;">Yes <span style="font-size: smaller;">(Official)</span></td>
      <td style="background-color: rgb(255,102,102);"><font>No</font></td>
      <td style="background-color: rgb(255,102,102);"><font>No</font></td>
    </tr>
    <tr>
      <th>VC9 (Visual Studio Codename "Orcas")</th>
      <td style="background-color: #6f6;">Yes <span style="font-size: smaller;">(Experimental)</span></td>
      <td style="background-color: rgb(255,102,102);"><font>No</font></td>
      <td style="background-color: rgb(255,102,102);"><font>No</font></td>
    </tr>
  </tbody>
</table>
<p><strong>Note 1</strong>: <a href="/en-US/docs/Windows_Build_Prerequisites_(1.7_and_1.8_Branches)" title="Windows_Build_Prerequisites_(1.7_&amp;_1.8_Branches)">Firefox 1.5/2.0 / Gecko 1.8.x build instructions</a> are not covered in this document.</p>
<p><strong>Note 2</strong>: All information about VC9/"Orcas" relate to the January CTP. It may or may not be correct for previous or future releases.</p>
<p><strong>Note 3</strong>: You can build the 1.8 branch with Visual Studio 2005 as follows:<br>
  The issue with Visual Studio 2005 is the need to have the .manifest files in the same directory as<br>
  the executable files when they are run and the need to update the windows version to at least 0x500 for<br>
  Windows RPC stubs<br>
  <br>
  1) Edit the configure file and set WINVER and _WIN32_WINNT to 0x500 (This is for Windows 2000 and above) then run ./configure &lt; your options here &gt;<br>
  2) Build as normally (you will eventually get an MSVCRT error for xpt_link)<br>
  3) When the error displays:<br>
  This copy assumes you are in the mozilla directory<br>
  copy xpcom\typelib\xpt\tools\*.manifest dist\bin<br>
  4) Issue the make command again<br>
  5) On build completion, copy the application manifest files from app\* into dist\bin.<br>
  You can find them by changing directory into the app folder and issuing a dir/s *.manifest<br>
  <br>
  The results of this build have not been thoroughly tested, your mileage may vary.</p>

<h3 id="Platform_SDK">Platform SDK</h3>
<p>Skip this step, if you are using Visual Studio .NET 2003 or later, because you already have all the necessary SDKs for building Mozilla. For older compilers, as well as for the free Visual Studio Express Editions, you need to download SDKs from Microsoft to have the GDI+ headers and library.</p>
<p>You can download the <a class="external" href="http://www.microsoft.com/downloads/details.aspx?FamilyId=A55B6B43-E24F-4EA3-A93E-40C0EC4F68E5&amp;displaylang=en">Windows Server 2003 SP1 Platform SDK</a>, or the <a class="external" href="http://www.microsoft.com/downloads/details.aspx?FamilyID=0baf2b35-c656-4969-ace8-e4c0c0716adb&amp;DisplayLang=en">Windows Server 2003 R2 Platform SDK</a>. You must install the "Windows Core SDK" (Tools, Build Environment, and Redistributable Components) and the "Web Workshop SDK" (Build Environment).</p>
<p>In order for the build environment to pick up this SDK, the SDK must be added to the build environment (see below).</p>

<h3 id="NSIS">NSIS</h3>
<p>Some applications built from the Mozilla codebase now use NSIS for their installer, notably the toolkit apps Firefox, Thunderbird and Sunbird. NSIS is already required during the normal build process because the uninstaller is built with the help of NSIS. If you do not disable building the installer with <code>ac_add_options --disable-installer</code> in your <code>.mozconfig</code> then install <a class="external" href="http://nsis.sourceforge.net/Download">NSIS</a> and ensure its install directory (not the 'Bin' directory in the install directory) is in your PATH. Version 2.17 or greater is recommended.</p>
<h3 id="7-Zip_and_UPX">7-Zip and UPX</h3>
<p>If you want to make the highly compressed installer used by Firefox and Thunderbird, you need to install the <a class="external" href="http://www.7-zip.org/">7-zip</a> and <a class="external" href="http://upx.sourceforge.net/">UPX</a> utilities, make sure they are in your path, and export MOZ_INSTALLER_USE_7ZIP in your environment.</p>
<p>The UPX package is available in <a class="external" href="http://cygwin.com/">Cygwin</a> setup under the Utils category. Do not use the DOS version, as it will not work.</p>

<h2 id="Configure_the_Environment">Configure the Environment</h2>
<p>The build environment must be configured so that the mozilla build system can find the proper compiler and libraries. This is best done with a DOS batch script. Your build may fail if your paths have spaces or other special characters. Make sure that you did not install software into locations with such paths, except Visual C++.</p>
<p>The following is a batch script (run with cmd.exe or modify the cygwin.bat file) which should be used to configure environment variables:</p>
<pre>rem --- Set HOME so that cvs and ssh work correctly
rem --- cvs uses HOME to locate your .cvspass file, and ssh to locate your .ssh file
rem --- if you are using ssh, your HOME should match the home directory specified in /etc/passwd. See <a class="external" href="http://www.cygwin.com/faq/faq0.html" rel="freelink">http://www.cygwin.com/faq/faq0.html</a>.
set HOME=C:\home

rem --- Set VCVARS to wherever the MSVC vcvars.bat file is found
set VCVARS=<var>C:\Program Files\Microsoft Visual Studio 8\VC\bin\vcvars32.bat</var>

rem --- Set MSSDK to wherever the MS SDK is installed
rem --- <strong>Only required for MSVC7 or the Free MSVC editions that don't come with an SDK</strong>
set MSSDK=<var>C:\Program Files\Microsoft Platform SDK</var>

rem --- Set MOZ_TOOLS to wherever you have the moztools packaged installed
set MOZ_TOOLS=<var>C:\moztools</var>

rem --- Set CYGWINBASE to wherever cygwin is installed
rem --- Do not use CYGWIN or else cygserver, cygrunsrv, and Cygwin services will not function properly
rem --- Variable CYGWIN is also used to modify Cygwin's behaviour a little bit.
set CYGWINBASE=<var>C:\cygwin</var>
rem --- Make sure Cygwin does not print out a DOS style path warning
set CYGWIN=<var>nodosfilewarning</var>

rem --- Prepend Cygwin path
rem --- This is necessary so that cygwin <code>find</code> is ahead of windows <code>find.exe</code> in the PATH, but cgywin <code>link</code> is after MSVC <code>link.exe</code>.
set PATH=%CYGWINBASE%\bin;%PATH%

rem --- Set MSVC environment vars
call "%VCVARS%"

rem --- Prepend SDK paths
rem --- <strong>Only required for MSVC7 or the Free MSVC editions that don't come with an SDK</strong>
set PATH=%MSSDK%\bin;%PATH%
set INCLUDE=%MSSDK%\include;%MSSDK%\include\atl;%INCLUDE%
set LIB=%MSSDK%\lib;%LIB%

rem --- moztools comes last
set PATH=%PATH%;%MOZ_TOOLS%\bin

rem --- Now the PATH variable contains:
rem MS-SDK; MSVC; Cygwin; Windows; glib/libIDL; Moztools

rem --- Typically the last thing the script does is launch a cygwin shell
rem --- watch for your ~/.profile and /etc/profile which may overwrite your carefully setup PATH!
bash --login -i
</pre>
<p>For a better terminal, check out <a class="external" href="http://web.gccaz.edu/~medgar/puttycyg/">PuTTYcyg</a>, a build of the PuTTY SSH client that can serve as a terminal for Cygwin. You can use the same batch file, just install PuTTYcyg somewhere on your path, then replace the last command of the batch file with this one, which starts Cygwin in a PuTTY shell:</p>
<pre>start putty -cygterm -
</pre>

<h3 id="Fix_cygwin_path">Fix cygwin path</h3>
<p>By default, cygwin puts itself at the beginning of PATH, breaking the order of our carefully constructed PATH. You can either</p>
<ul>
  <li>edit /etc/profile/ = %CYGWINBASE%\etc\profile (use an editor which preserves Unix line endings - cygwin package <code>nano</code>, if in doubt), changing the line</li>
</ul>
<pre>PATH=/usr/local/bin:/usr/bin:/bin:/usr/X11R6/bin:$PATH
to
PATH=$PATH:/usr/local/bin:/usr/bin:/bin:/usr/X11R6/bin
</pre>
<ul>
  <li>or add a .profile or .bash_profile to your home dir.</li>
</ul>
<p>This is required so that Make selects the right instance of the file "link.exe". If you decide not to mess with the Cygwin PATH, rename link.exe to something else. You can also make the batch file do this automatically on startup, and undo it on shutdown. To do that, replace the following line in your batch file:</p>
<pre>bash --login -i</pre>
<p>with this:</p>
<pre>rename link.exe cyglink.exe
bash --login -i
rename cyglink.exe link.exe</pre>
<p>If you are using this method, don't forget to quit from the Cygwin shell by typing "Exit", instead of just closing the window.</p>

<h2 id="Common_Problems.2C_Hints_and_Restrictions">Common Problems, Hints and Restrictions</h2>
<ul>
  <li>Check the <a href="/en-US/docs/Mozilla_Build_FAQ#Win32-specific_questions" title="Mozilla_Build_FAQ#Win32-specific_questions">Mozilla Build Frequently Asked Questions</a>, they list a number of very often encountered build problems.</li>
  <li>If you have chosen DOS-style line endings when installing cygwin, your source and object trees must be located at a /cygdrive/&lt;c&gt; mount point. It must not be located within your /home.</li>
  <li>Mozilla may not build if you install the moztools directory inside the cygwin directory.</li>
  <li>The build may fail if your PATH environment variable contains quotes ("). Quotes are not properly translated when passed down to the cygwin sub-shells. Quotes are usually not needed so they can be removed.</li>
  <li>Double-check to make sure that you have the complete cygwin package list. If not, launch the cygwin installer and add the missing packages.
    <ul>
      <li>From the Cygwin Mailing Lists, the behaviour change in make 3.81 was caused by a patch for DOS style paths being removed.</li>
    </ul>
 </li>
  <li><a href="/en-US/docs/Debugging_Mozilla_on_Windows_FAQ" title="Debugging_Mozilla_on_Windows_FAQ">Debugging Mozilla on Windows FAQ</a>: Tips on how to debug Mozilla on Windows.</li>
  <li><a href="/en-US/docs/Developer_Guide/Build_Instructions/Windows_Prerequisites" title="Windows_Build_Prerequisites">Upgrading a Windows build system from VC6 to VC7?</a></li>
</ul>
